<!--
Abstract:

Konfigurationsmanagement Chef - eine praktische Einführung

Mit wachsender Infrastruktur steigt der Bedarf nach Automatisierung. Dies soll durch Konfigurationsmanagement gelöst werden. In diesem Vortrag wird Chef[1] vorgestellt werden. Nach einem kurzen Vergleich mit dem artverwandten Konfigurationsmanagement Puppet[2], wird auf die Grundkonzepte in Chef eingangen. Es wird gezeigt, wie einfache Cookbooks in Chef aufgebaut sind und diese geschrieben und getestet werden. Zum Schluss folgt eine kurze Vorführung des Programms.

[1] http://www.getchef.com/
[2] http://puppetlabs.com/
-->

<!--
Multi-Monitor-Shortcuts:
Ctrl-O: Move Window to next screen
Mod4 + Control + j/k: Focus next/previous screen

reveal.js-Shortcuts:
o: Öffne Übersicht
s: Öffne Vortragsmonitor
-->

<!-- .slide: data-state="intro" -->
# Linux Cluster in Theorie und Praxis

## Konfigurationsmanagement Chef - Eine praktische Einführung

von Jörg Thalheim

4\. März 2014

<img src="img/ugly_penguin.png" alt="Penguin">

<a class="email" href="s5245332@mail.zih.tu-dresden.de">s5245332@mail.zih.tu-dresden.de</a>

Note:
- Vorstellen
- Thema



## Inhaltsübersicht

- Was ist Konfigurationsmanagement
- Was ist Chef/Puppet
- Einführung in Chef
- Tests
- Demo

Note:
- Vortrag hier mal die wichtigsten Punkte kurz im Überblick
- Wozu brauche ich Chef und andere Konfigurationsmanagements
- Danach Vergleich der 2 Rivalen Chef/Puppet
- Zeige wie Chef funktioniert
- Wie sieht der Arbeitsablauf beim Entwickeln mit Hilfe von Tests aus
- Zum Schluss: Ergebnis meiner Abschlussaufgabe - Einrichtung von
  Netzwerkdiensten mit Chef



## Was ist Konfigurationsmanagement?

- Konfigurationsmanagement
- Beispiele: Chef, Puppet, Salt, Ansible, CFEngine

<img src="img/chef_logo.png" height="150" alt="Chef">
<img src="img/puppet_logo.png" height="150" alt="Puppet">
<img src="img/saltstack_logo.jpg" height="150" alt="Salt">
<img src="img/ansible_logo.png" height="150" alt="Ansible">
<img src="img/cfengine_logo.jpg" height="150" alt="CFEngine">

Note:
- in der Praxis mehr Knoten
- Teams mit wechselnde Mitarbeiter, geografisch verteilt
- Dokumentation veraltet schnell
- sowohl bestehende Knoten müssen aktuell gehalten werden,
  als auch neue eingerichtet
- Häufig Shell-Skripte für Automatisierung:
  -> schnell komplex und schlecht maintainbar,
  -> häufig nicht portable und langsam
- Problem wird durch Konfigurationsmanagements gelöst.
  eingehen.
- Hier ein paar Beispiele gelistet: -> Puppet/Chef
- Grundidee:
  - Zustand durch Konfigurationsdatei/Sprache beschrieben
  - Konfigurationsmanagement: Herstellung des Zustands.



## Was ist Chef/Puppet?

<table class="reveal">
<thead>
  <tr>
    <th>Kriterium</th>
    <th>Chef</th>
    <th>Puppet</th>
  </tr>
</thead>
<tbody>
  <tr>
    <th>Programmiersprache</th>
    <td>Ruby</td>
    <td>Ruby</td>
  </tr>
  <tr>
    <th>Konfigurationsprache</th>
    <td>Ruby</td>
    <td>eigene DSL (Ruby)</td>
  </tr>
  <tr>
    <th>Paradigma</th>
    <td>Prozedural</td>
    <td>Model-Driven</td>
  </tr>
<!--
  <tr>
    <th>Codezeilen</th>
    <td>108,726<sup>[1][1]</sup></td>
    <td>353,651<sup>[2][2]</sup></td>
  </tr>
-->
  <tr>
    <th>Community</th>
    <td>11,270 Repositories auf Github<sup>[1][1]</sup></td>
    <td>13.020 Repositories auf Github<sup>[2][2]</sup></td>
  </tr>
  <tr>
    <th>kommerzieller Support</th>
    <td>&#10003;</td>
    <td>&#10003;</td>
  </tr>
</tbody>
</table>

[1]: https://github.com/search?q=chef
[2]: https://github.com/search?q=puppet
<!--
[1]: https://www.ohloh.net/p/puppet
[2]: https://www.ohloh.net/p/chef
-->


Note:
- Beide Projekte sind in Ruby geschrieben.
- Chef: Konfigurations in Ruby
- Puppet: eine auf Puppet optimierte, vereinfachte Sprache
  -> einfacher für Einsteiger und Nicht-Programmieren
  -> Grund für manche Firmen -> wird um Umschulung zu sparen
  -> weniger flexible als Ruby (Grund bei Facebook, mehre Cluster mit mehr als 10.000 Nodes mit Chef provisionier)
- Während die Regeln und Beschreibung in Chef standartmäßig in der Reihenfolge abgearbeitet
  wird in der sie geladen werden, sortiert Puppet diese um. In beiden kann die
  Reihenfolge durch Spezifikation von Abhängigkeiten umsortiert werden (Später
  ein Beispiel)
- Puppet: eigene Sprache -> komplexere Codebasis
- Um die Größe der Community abzuschätzen (schwierig): Suchtreffer für Repositories bei Github
- Alter(Puppet) > Alter(Chef)
- Hinter beiden Projekten stehen Firmen, Weiterentwicklung des Produkt, bieten Support und Hosting an
- Resume: Ähnliche Projekte, lösen das gleiche Problem auf unterschiedliche
  Weise


## Einführung in Chef



### Chef-Einführung: Grundbegriffe
  - Node, z.B.: node100.tu-dresden.de
  - Role, z.B.: headnode, ldap
  - Cookbook, z.B. slurm
  - Recipe, slurm::slurmctld oder slurm::slurmd
  - Resource, z.B.: package["slurm"], template["/etc/slurm.conf"], service["slurmctld"]

Note:
- Zunächst ein paar wichtige Begriffe:
- chef: engl. für Koch
- viele Begriffe vom Kochen abgeleitet
- Jede Maschine wird in chef Node genannt.
- Nodes können Rollen zugewiesen werden, um welche bestimmte Aufgaben und
  Attribute zusammenfassen.
- Die grundlegende Verwaltungseinheit ist das cookbook. Ein cookbook
  beschreibt alles was eingerichtet und konfiguriert werden muss um eine bestimmte Aufgabe zu erledigen. z.B. dem Einrichten des
  Batchsystems slurm
- In einem cookbook können wiederum mehrere Recipes enthalten sein, um bestimmte
  Unteraufgaben zu erfüllen. So könnte im Falle von slurm, auf der Headnode das
  Recipe für den Slurm-Kontrolldaemon zugewiesen werden, während auf dem
  Computenodes jeweils ein slurmd eingerichtet wird.
- In einem Recipe werden wiederum verschiedene Resourcen beschrieben.
- chef überprüft, bei jeder Resource, ob diese in dem gewünchten Zustand ist.
  Dabei ist für jede Resource definiert, wie man vom aktuellen Zustand in den
  gewünschten Zustand kommt.
- Im Falle des Slurmctld könnten das z.B.:
    - das Packet slurm, welches installiert werden soll
    - die Konfiguration /etc/slurm.conf
    - der Dienst slurmctld, welcher gestartet werden soll.



### Chef-Einführung: Aufbau eines Cookbook

```bash
▾ modules/
  ▾ attributes/
      default.rb
  ▾ files/
    ▾ default/
        modules-load.conf
        modules-load_header
  ▸ libraries/
  ▾ providers/
      default.rb
      multi.rb
  ▾ recipes/
      config.rb
      default.rb
      install_attributes.rb
  ▾ resources/
      default.rb
      multi.rb
  ▾ templates/
    ▾ default/
        modules.conf.erb
    metadata.json
    metadata.rb
    Rakefile
    README.md
```

Note:
  - Hier ein Beispiel, wie ein cookbook aufgebaut ist.
  - modules cookbook: Linux Kernel Module nachladen, maintained auf github
  - Verzeichnisstruktur vorgeben - Vorteil man findet sich in neuen Cookbooks
    sofort zu recht
  - Für das entwickeln: Editor mit Verzeichnisfunktion empfohlen
  - hier nochmal kurz ein paar wichtige Verzeichnisse:
    - attributes: setzt Standartwerte für das Cookbook, können von Roles/Nodes
      oder anderen Cookbooks überschrieben werden
    - resourcen & providers: Chef liefert schon eine Menge sinnvoller Resourcen
      mit, man kann in seinem cookbooks weitere erstellen, in diesem Fall -
      modules resource mit der man in anderen cookbooks bestimmte kernel module laden
      kann
    - recipes: enthält die genannten Recipes, wenn man nichts an gibt wird die
      default.rb geladen
    - files: Im files-Verzeichnis können statische Konfigurations-Dateien abgelegt werden
    - templates: meistens jedoch will Konfigurationsdateien dynamisch
      generieren - dazu mit Templates man mithilfe mit der Markupsprache ERB generieren,
      vergleichbar mit erzeugen von Webseiten, gleich ein Beispiel dazu



### Chef-Einführung: Code-Beispiel

```ruby
# attributes/default.rb
default.ntp.server = "de.pool.ntp.org"
default.ntp.subnets = ["::1", "127.0.0.1"]
```

```ruby
# recipes/default.rb
package 'ntp'

template "/etc/ntp.conf" do
  owner "root"
  group "root"
  source "ntp.conf.erb"
  notifies :restart, "service[ntp]"
end

service "ntp" do
  action [:enable, :start]
end
```

Note:
  - das beliebte Hello-World für Provisionierungssysteme: Einrichten eines
    NTP-Servers
  - Hier ein Beispiel, welches ich für die Abschlussaufgabe geschrieben habe
  - attribute: In der Attribute-Datei - Standwerte für ntp: upstream server,
    subnets auf dem ntp lauscht



### Chef-Einführung: Code-Beispiel

```ruby
# recipes/default.rb
package 'ntp'

template "/etc/ntp.conf" do
  owner "root"
  group "root"
  source "ntp.conf.erb"
  notifies :restart, "service[ntp]"
end

service "ntp" do
  action [:enable, :start]
end
```

```ruby
# templates/default/ntp.conf.erb
# Crontab for <%= @node.name %> managed by Chef. Changes will be overwritten.
server <%= @node.ntp.server %>

restrict default noquery nopeer
<% @node.ntp.subnets.each do |net| -%>
  restrict <%= net %>
<% end -%>

driftfile /var/lib/ntp/ntp.drift
```

Note:
  - recipe:
      - package: Packet per apt installieren
      - template: Konfiguration aus template generieren
      - zum Schluss: Dienst aktivieren und starten
      - hier Abhängigkeiten zwischen Resourcen, wenn Template sich ändert -> NTP neustarten
  - template:
    - Beispiel für ERB-Template
    - Tags -> Ruby-Code, wird interpoliert
    - Verzweigungen und Schleifen möglich



## Tests

<img src="img/dont_always.jpg" alt="I don't always test my code">

Note:
- Infrastruktur: schwierig zu testen, viele externe Abhängigkeiten, langsam
- Ruby: dynamische Programmiersprache -> Tippfehler, keine Compilerwarnung beim
  Refactoring
- 2 Testframeworks angeschaut



## Tests: Chef Spec
```ruby
# spec/cookbooks/ntp_spec.rb
require_relative '../spec_helper'

describe 'ntp::default' do
  let(:chef_run) do
    ChefSpec::Runner.new do |node|
      subnets = ["::1", "127.0.0.1",
        "172.28.128.0 mask 255.255.255.0 nomodify notrap nopeer"]
      node.set["ntp"]["subnets"] = subnets
    end.converge(described_recipe)
  end

  it "should setup ntp" do
    chef_run.should install_package("ntp")
    chef_run.should render_file("/etc/ntp.conf").with_content("172.28.128.0")
  end
end
```

Note:
- Chef: 2 Phasen der Ausführung: Converging und eigentliche Ausführungsphase
- Converging: Einlesen aller Resourcen -> Abhängigkeitsbaum
- Chefspec: Nur Convergingphase
    -> Vorteil: sehr schnell (1s), keine Abhängigkeiten beim Testen außer Chef
    -> Nachteil: es wird nichts ausgeführt
    - gut für schnelle Validierung, Testen vom Zusammenspiel verschiedener
      Module, einfache Logik testen, Tippfehler
- chef\_run: Attribute des Nodes
- it-block: Eigentliche Assertions
Chefspec Geschwindigkeit zeigen:
- bundle exec rspec spec



## Tests: Minitest Chef Handler

```ruby
# ntp/files/default/test/default_test.rb
require 'minitest/spec'

describe_recipe 'ntp::default' do
  it "starts the ntp daemon" do
    assert_sh("service ntp status")
  end
  it "should sync the time" do
    assert_sh("ntpq -p")
  end
end
```

Note:
- Minitest: werden nach jedem Deployment gestartet
  -> Integrationstests
- Ähnliche Healtschecks wie bei Monitoringsystemen oder unserem Test während des Praktikum
  -> Benachrichtung via Chefhandler möglich z.B. per Email, Jabber, ...



## Demo

Note:
- Abschlussaufgabe: Einrichten von 2 beliebigen Netzwerksdiensten wie im Praktikum
- In meinen Fall: NTP, Dns mit Bind, DHCP
- Vagrant: Starten einer Headnode: mehre Computenodes bekommen über das interne
  Netzwerk per DHCP eine IP, nutzen das DNS und NTP des Headnode, Headnode als
  Router
Vorbereitung
- ssh-add -d # SSH-Schlüssel löschen
- vagrant up node0.lctp
- vagrant up node1.lctp
- vagrant up node2.lctp --no-provision
- vagrant provision node2.lctp --provision-with shell
Ablauf:
- Headnode: Schon provisioniert
  node0:
    - vagrant ssh node0.lctp
    - ip a
    - service isc-dhcp-server statu
    - ntpq -p
    - dig node0.lctp @localhost
- 1. Computenode: provisioniert
  node0:
    - vagrant ssh node1.lctp
    - ip a
    - ip route
    - ntpq -p
- 2. Computenode: neu provisionieren
    - auskommentieren
    - vagrant up node2.lctp
    - vagrant: Entwicklungsumgebung mit der gleichen Konfiguration wie Production
      einrichten
    - besonderheiten chef-solo/chef-server
    - minitests zeigen
    - Fehlermeldung -> vagrant
    - ntpq -p
    - mtr 8.8.8.8
- Headnode verkonfigurieren -> erneutes Provisioning
    node0:
    - sudo iptables -L -t na
    - sudo iptables -F -t na
    - sudo iptables -L -t na
    node2: ping 8.8.8.8 # laufen lassen
    node0:
    - sudo vi /etc/ntp.conf # server de -> us
    - sudo service bind9 stop
    - vagrant provision node0.lctp # wechseln zu node2
- Fragen?
