Description
===========

wrapper cookbook around [network\_interfaces](http://community.opscode.com/cookbooks/network_interfaces),
to allow set up network interfaces via node attributes

Attributes
==========

default.lctp_network.interfaces, hash of available interfaces (see usage), default is {}
default.lctp_network.domain_servers, statically set domain servers, default is []
default.lctp_network.search_domains, statically set search domains, default is []

default.lctp_network.router.gateway_device = "eth0"

Usage
=====

default
-------

example to set a static ip, with custom dns server and search domain:


      node.default["lctp_network"]["interfaces"] = {
        eth0: {
         dns_server: "127.0.0.1",
         dns_search: "intern",
         static_ip: "172.28.128.1",
         netmask: "255.255.255.0"
        },
      }


example to enable dhcp for a device:

      node.default["lctp_network"]["interfaces"] = {
        eth0: { },
      }

router
------

Enable IP Forwarding and Masquerading via iptables
